#include <mapiwin.h>
#include <mapi.h>
#include <mapix.h>
#include <xcmc.h>

#define NUM_TABLES  22

/* Data for table: MAPIErrors */

static ENTRY s1[98] = 
{
    SUCCESS_SUCCESS,    "SUCCESS_SUCCESS",
    MAPI_E_CALL_FAILED, "MAPI_E_CALL_FAILED",
    MAPI_E_NOT_ENOUGH_MEMORY,   "MAPI_E_NOT_ENOUGH_MEMORY",
    MAPI_E_INVALID_PARAMETER,   "MAPI_E_INVALID_PARAMETER",
    MAPI_E_INTERFACE_NOT_SUPPORTED, "MAPI_E_INTERFACE_NOT_SUPPORTED",
    MAPI_E_NO_ACCESS,   "MAPI_E_NO_ACCESS",
    MAPI_E_NO_SUPPORT,  "MAPI_E_NO_SUPPORT",
    MAPI_E_BAD_CHARWIDTH,   "MAPI_E_BAD_CHARWIDTH",
    MAPI_E_STRING_TOO_LONG, "MAPI_E_STRING_TOO_LONG",
    MAPI_E_UNKNOWN_FLAGS,   "MAPI_E_UNKNOWN_FLAGS",
    MAPI_E_INVALID_ENTRYID, "MAPI_E_INVALID_ENTRYID",
    MAPI_E_INVALID_OBJECT,  "MAPI_E_INVALID_OBJECT",
    MAPI_E_OBJECT_CHANGED,  "MAPI_E_OBJECT_CHANGED",
    MAPI_E_OBJECT_DELETED,  "MAPI_E_OBJECT_DELETED",
    MAPI_E_BUSY,    "MAPI_E_BUSY",
    MAPI_E_NOT_ENOUGH_DISK, "MAPI_E_NOT_ENOUGH_DISK",
    MAPI_E_NOT_ENOUGH_RESOURCES,    "MAPI_E_NOT_ENOUGH_RESOURCES",
    MAPI_E_NOT_FOUND,   "MAPI_E_NOT_FOUND",
    MAPI_E_VERSION, "MAPI_E_VERSION",
    MAPI_E_LOGON_FAILED,    "MAPI_E_LOGON_FAILED",
    MAPI_E_SESSION_LIMIT,   "MAPI_E_SESSION_LIMIT",
    MAPI_E_USER_CANCEL, "MAPI_E_USER_CANCEL",
    MAPI_E_UNABLE_TO_ABORT, "MAPI_E_UNABLE_TO_ABORT",
    MAPI_E_NETWORK_ERROR,   "MAPI_E_NETWORK_ERROR",
    MAPI_E_DISK_ERROR,  "MAPI_E_DISK_ERROR",
    MAPI_E_TOO_COMPLEX, "MAPI_E_TOO_COMPLEX",
    MAPI_E_BAD_COLUMN,  "MAPI_E_BAD_COLUMN",
    MAPI_E_EXTENDED_ERROR,  "MAPI_E_EXTENDED_ERROR",
    MAPI_E_COMPUTED,    "MAPI_E_COMPUTED",
    MAPI_E_END_OF_SESSION,  "MAPI_E_END_OF_SESSION",
    MAPI_E_UNKNOWN_ENTRYID, "MAPI_E_UNKNOWN_ENTRYID",
    MAPI_E_MISSING_REQUIRED_COLUMN, "MAPI_E_MISSING_REQUIRED_COLUMN",
    MAPI_W_NO_SERVICE,  "MAPI_W_NO_SERVICE",
    MAPI_E_BAD_VALUE,   "MAPI_E_BAD_VALUE",
    MAPI_E_INVALID_TYPE,    "MAPI_E_INVALID_TYPE",
    MAPI_E_TYPE_NO_SUPPORT, "MAPI_E_TYPE_NO_SUPPORT",
    MAPI_E_UNEXPECTED_TYPE, "MAPI_E_UNEXPECTED_TYPE",
    MAPI_E_TOO_BIG, "MAPI_E_TOO_BIG",
    MAPI_W_ERRORS_RETURNED, "MAPI_W_ERRORS_RETURNED",
    MAPI_E_UNABLE_TO_COMPLETE,  "MAPI_E_UNABLE_TO_COMPLETE",
    MAPI_E_TABLE_EMPTY, "MAPI_E_TABLE_EMPTY",
    MAPI_E_TABLE_TOO_BIG,   "MAPI_E_TABLE_TOO_BIG",
    MAPI_E_INVALID_BOOKMARK,    "MAPI_E_INVALID_BOOKMARK",
    MAPI_W_POSITION_CHANGED,    "MAPI_W_POSITION_CHANGED",
    MAPI_W_APPROX_COUNT,    "MAPI_W_APPROX_COUNT",
    MAPI_E_WAIT,    "MAPI_E_WAIT",
    MAPI_E_CANCEL,  "MAPI_E_CANCEL",
    MAPI_E_NOT_ME,  "MAPI_E_NOT_ME",
    MAPI_W_CANCEL_MESSAGE,  "MAPI_W_CANCEL_MESSAGE",
    MAPI_E_CORRUPT_STORE,   "MAPI_E_CORRUPT_STORE",
    MAPI_E_NOT_IN_QUEUE,    "MAPI_E_NOT_IN_QUEUE",
    MAPI_E_NO_SUPPRESS, "MAPI_E_NO_SUPPRESS",
    MAPI_E_COLLISION,   "MAPI_E_COLLISION",
    MAPI_E_NOT_INITIALIZED, "MAPI_E_NOT_INITIALIZED",
    MAPI_E_NON_STANDARD,    "MAPI_E_NON_STANDARD",
    MAPI_E_NO_RECIPIENTS,   "MAPI_E_NO_RECIPIENTS",
    MAPI_E_SUBMITTED,   "MAPI_E_SUBMITTED",
    MAPI_E_HAS_FOLDERS, "MAPI_E_HAS_FOLDERS",
    MAPI_E_HAS_MESSAGES,    "MAPI_E_HAS_MESSAGES",
    MAPI_E_FOLDER_CYCLE,    "MAPI_E_FOLDER_CYCLE",
    MAPI_W_PARTIAL_COMPLETION,  "MAPI_W_PARTIAL_COMPLETION",
    MAPI_E_AMBIGUOUS_RECIP, "MAPI_E_AMBIGUOUS_RECIP",
    MAPI_USER_ABORT,    "MAPI_USER_ABORT",
    MAPI_E_USER_ABORT,  "MAPI_E_USER_ABORT",
    MAPI_E_FAILURE, "MAPI_E_FAILURE",
    MAPI_E_LOGON_FAILURE,   "MAPI_E_LOGON_FAILURE",
    MAPI_E_LOGIN_FAILURE,   "MAPI_E_LOGIN_FAILURE",
    MAPI_E_DISK_FULL,   "MAPI_E_DISK_FULL",
    MAPI_E_INSUFFICIENT_MEMORY, "MAPI_E_INSUFFICIENT_MEMORY",
    MAPI_E_ACCESS_DENIED,   "MAPI_E_ACCESS_DENIED",
    MAPI_E_TOO_MANY_SESSIONS,   "MAPI_E_TOO_MANY_SESSIONS",
    MAPI_E_TOO_MANY_FILES,  "MAPI_E_TOO_MANY_FILES",
    MAPI_E_TOO_MANY_RECIPIENTS, "MAPI_E_TOO_MANY_RECIPIENTS",
    MAPI_E_ATTACHMENT_NOT_FOUND,    "MAPI_E_ATTACHMENT_NOT_FOUND",
    MAPI_E_ATTACHMENT_OPEN_FAILURE, "MAPI_E_ATTACHMENT_OPEN_FAILURE",
    MAPI_E_ATTACHMENT_WRITE_FAILURE,    "MAPI_E_ATTACHMENT_WRITE_FAILURE",
    MAPI_E_UNKNOWN_RECIPIENT,   "MAPI_E_UNKNOWN_RECIPIENT",
    MAPI_E_BAD_RECIPTYPE,   "MAPI_E_BAD_RECIPTYPE",
    MAPI_E_NO_MESSAGES, "MAPI_E_NO_MESSAGES",
    MAPI_E_INVALID_MESSAGE, "MAPI_E_INVALID_MESSAGE",
    MAPI_E_TEXT_TOO_LARGE,  "MAPI_E_TEXT_TOO_LARGE",
    MAPI_E_INVALID_SESSION, "MAPI_E_INVALID_SESSION",
    MAPI_E_TYPE_NOT_SUPPORTED,  "MAPI_E_TYPE_NOT_SUPPORTED",
    MAPI_E_AMBIGUOUS_RECIPIENT, "MAPI_E_AMBIGUOUS_RECIPIENT",
    MAPI_E_AMBIG_RECIP, "MAPI_E_AMBIG_RECIP",
    MAPI_E_MESSAGE_IN_USE,  "MAPI_E_MESSAGE_IN_USE",
    MAPI_E_NETWORK_FAILURE, "MAPI_E_NETWORK_FAILURE",
    MAPI_E_INVALID_EDITFIELDS,  "MAPI_E_INVALID_EDITFIELDS",
    MAPI_E_INVALID_RECIPS,  "MAPI_E_INVALID_RECIPS",
    MAPI_E_NOT_SUPPORTED,   "MAPI_E_NOT_SUPPORTED",
    E_NOTIMPL,  "E_NOTIMPL",
    E_UNEXPECTED,   "E_UNEXPECTED",
    E_OUTOFMEMORY,  "E_OUTOFMEMORY",
    E_INVALIDARG,   "E_INVALIDARG",
    E_NOINTERFACE,  "E_NOINTERFACE",
    E_POINTER,  "E_POINTER",
    E_HANDLE,   "E_HANDLE",
    E_ABORT,    "E_ABORT"
};

/* Data for table: CMCErrors */

static ENTRY s2[39] = 
{
    CMC_SUCCESS,    "CMC_SUCCESS",
    CMC_E_AMBIGUOUS_RECIPIENT,  "CMC_E_AMBIGUOUS_RECIPIENT",
    CMC_E_ATTACHMENT_NOT_FOUND, "CMC_E_ATTACHMENT_NOT_FOUND",
    CMC_E_ATTACHMENT_OPEN_FAILURE,  "CMC_E_ATTACHMENT_OPEN_FAILURE",
    CMC_E_ATTACHMENT_READ_FAILURE,  "CMC_E_ATTACHMENT_READ_FAILURE",
    CMC_E_ATTACHMENT_WRITE_FAILURE, "CMC_E_ATTACHMENT_WRITE_FAILURE",
    CMC_E_COUNTED_STRING_UNSUPPORTED,   "CMC_E_COUNTED_STRING_UNSUPPORTED",
    CMC_E_DISK_FULL,    "CMC_E_DISK_FULL",
    CMC_E_FAILURE,  "CMC_E_FAILURE",
    CMC_E_INSUFFICIENT_MEMORY,  "CMC_E_INSUFFICIENT_MEMORY",
    CMC_E_INVALID_CONFIGURATION,    "CMC_E_INVALID_CONFIGURATION",
    CMC_E_INVALID_ENUM, "CMC_E_INVALID_ENUM",
    CMC_E_INVALID_FLAG, "CMC_E_INVALID_FLAG",
    CMC_E_INVALID_MEMORY,   "CMC_E_INVALID_MEMORY",
    CMC_E_INVALID_MESSAGE_PARAMETER,    "CMC_E_INVALID_MESSAGE_PARAMETER",
    CMC_E_INVALID_MESSAGE_REFERENCE,    "CMC_E_INVALID_MESSAGE_REFERENCE",
    CMC_E_INVALID_PARAMETER,    "CMC_E_INVALID_PARAMETER",
    CMC_E_INVALID_SESSION_ID,   "CMC_E_INVALID_SESSION_ID",
    CMC_E_INVALID_UI_ID,    "CMC_E_INVALID_UI_ID",
    CMC_E_LOGON_FAILURE,    "CMC_E_LOGON_FAILURE",
    CMC_E_MESSAGE_IN_USE,   "CMC_E_MESSAGE_IN_USE",
    CMC_E_NOT_SUPPORTED,    "CMC_E_NOT_SUPPORTED",
    CMC_E_PASSWORD_REQUIRED,    "CMC_E_PASSWORD_REQUIRED",
    CMC_E_RECIPIENT_NOT_FOUND,  "CMC_E_RECIPIENT_NOT_FOUND",
    CMC_E_SERVICE_UNAVAILABLE,  "CMC_E_SERVICE_UNAVAILABLE",
    CMC_E_TEXT_TOO_LARGE,   "CMC_E_TEXT_TOO_LARGE",
    CMC_E_TOO_MANY_FILES,   "CMC_E_TOO_MANY_FILES",
    CMC_E_TOO_MANY_RECIPIENTS,  "CMC_E_TOO_MANY_RECIPIENTS",
    CMC_E_UNABLE_TO_NOT_MARK_AS_READ,   "CMC_E_UNABLE_TO_NOT_MARK_AS_READ",
    CMC_E_UNRECOGNIZED_MESSAGE_TYPE,    "CMC_E_UNRECOGNIZED_MESSAGE_TYPE",
    CMC_E_UNSUPPORTED_ACTION,   "CMC_E_UNSUPPORTED_ACTION",
    CMC_E_UNSUPPORTED_CHARACTER_SET,    "CMC_E_UNSUPPORTED_CHARACTER_SET",
    CMC_E_UNSUPPORTED_DATA_EXT, "CMC_E_UNSUPPORTED_DATA_EXT",
    CMC_E_UNSUPPORTED_FLAG, "CMC_E_UNSUPPORTED_FLAG",
    CMC_E_UNSUPPORTED_FUNCTION_EXT, "CMC_E_UNSUPPORTED_FUNCTION_EXT",
    CMC_E_UNSUPPORTED_VERSION,  "CMC_E_UNSUPPORTED_VERSION",
    CMC_E_USER_CANCEL,  "CMC_E_USER_CANCEL",
    CMC_E_USER_NOT_LOGGED_ON,   "CMC_E_USER_NOT_LOGGED_ON",
    CMC_ERROR_DISPLAYED,    "CMC_ERROR_DISPLAYED"
};

/* Data for table: PropTags */

static ENTRY s3[338] = 
{
    PR_ACKNOWLEDGEMENT_MODE,    "PR_ACKNOWLEDGEMENT_MODE",
    PR_ALTERNATE_RECIPIENT_ALLOWED, "PR_ALTERNATE_RECIPIENT_ALLOWED",
    PR_AUTHORIZING_USERS,   "PR_AUTHORIZING_USERS",
    PR_AUTO_FORWARD_COMMENT,    "PR_AUTO_FORWARD_COMMENT",
    PR_AUTO_FORWARDED,  "PR_AUTO_FORWARDED",
    PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID,    "PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID",
    PR_CONTENT_CORRELATOR,  "PR_CONTENT_CORRELATOR",
    PR_CONTENT_IDENTIFIER,  "PR_CONTENT_IDENTIFIER",
    PR_CONTENT_LENGTH,  "PR_CONTENT_LENGTH",
    PR_CONTENT_RETURN_REQUESTED,    "PR_CONTENT_RETURN_REQUESTED",
    PR_CONVERSATION_KEY,    "PR_CONVERSATION_KEY",
    PR_CONVERSION_EITS, "PR_CONVERSION_EITS",
    PR_CONVERSION_WITH_LOSS_PROHIBITED, "PR_CONVERSION_WITH_LOSS_PROHIBITED",
    PR_CONVERTED_EITS,  "PR_CONVERTED_EITS",
    PR_DEFERRED_DELIVERY_TIME,  "PR_DEFERRED_DELIVERY_TIME",
    PR_DELIVER_TIME,    "PR_DELIVER_TIME",
    PR_DISCARD_REASON,  "PR_DISCARD_REASON",
    PR_DISCLOSURE_OF_RECIPIENTS,    "PR_DISCLOSURE_OF_RECIPIENTS",
    PR_DL_EXPANSION_HISTORY,    "PR_DL_EXPANSION_HISTORY",
    PR_DL_EXPANSION_PROHIBITED, "PR_DL_EXPANSION_PROHIBITED",
    PR_EXPIRY_TIME, "PR_EXPIRY_TIME",
    PR_IMPLICIT_CONVERSION_PROHIBITED,  "PR_IMPLICIT_CONVERSION_PROHIBITED",
    PR_IMPORTANCE,  "PR_IMPORTANCE",
    PR_IPM_ID,  "PR_IPM_ID",
    PR_LATEST_DELIVERY_TIME,    "PR_LATEST_DELIVERY_TIME",
    PR_MESSAGE_CLASS,   "PR_MESSAGE_CLASS",
    PR_MESSAGE_DELIVERY_ID, "PR_MESSAGE_DELIVERY_ID",
    PR_MESSAGE_SECURITY_LABEL,  "PR_MESSAGE_SECURITY_LABEL",
    PR_OBSOLETED_IPMS,  "PR_OBSOLETED_IPMS",
    PR_ORIGINALLY_INTENDED_RECIPIENT_NAME,  "PR_ORIGINALLY_INTENDED_RECIPIENT_NAME",
    PR_ORIGINAL_EITS,   "PR_ORIGINAL_EITS",
    PR_ORIGINATOR_CERTIFICATE,  "PR_ORIGINATOR_CERTIFICATE",
    PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED,    "PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED",
    PR_ORIGINATOR_RETURN_ADDRESS,   "PR_ORIGINATOR_RETURN_ADDRESS",
    PR_PARENT_KEY,  "PR_PARENT_KEY",
    PR_PRIORITY,    "PR_PRIORITY",
    PR_PROOF_OF_SUBMISSION_REQUESTED,   "PR_PROOF_OF_SUBMISSION_REQUESTED",
    PR_READ_RECEIPT_REQUESTED,  "PR_READ_RECEIPT_REQUESTED",
    PR_RECEIPT_TIME,    "PR_RECEIPT_TIME",
    PR_RECIPIENT_REASSIGNMENT_PROHIBITED,   "PR_RECIPIENT_REASSIGNMENT_PROHIBITED",
    PR_REDIRECTION_HISTORY, "PR_REDIRECTION_HISTORY",
    PR_RELATED_IPMS,    "PR_RELATED_IPMS",
    PR_LANGUAGES,   "PR_LANGUAGES",
    PR_REPLY_TIME,  "PR_REPLY_TIME",
    PR_REPORT_TAG,  "PR_REPORT_TAG",
    PR_REPORT_TIME, "PR_REPORT_TIME",
    PR_RETURNED_IPM,    "PR_RETURNED_IPM",
    PR_SECURITY,    "PR_SECURITY",
    PR_INCOMPLETE_COPY, "PR_INCOMPLETE_COPY",
    PR_SENSITIVITY, "PR_SENSITIVITY",
    PR_SUBJECT, "PR_SUBJECT",
    PR_SUBJECT_IPM, "PR_SUBJECT_IPM",
    PR_CLIENT_SUBMIT_TIME,  "PR_CLIENT_SUBMIT_TIME",
    PR_REPORT_NAME, "PR_REPORT_NAME",
    PR_SENT_REPRESENTING_SEARCH_KEY,    "PR_SENT_REPRESENTING_SEARCH_KEY",
    PR_X400_CONTENT_TYPE,   "PR_X400_CONTENT_TYPE",
    PR_NON_RECEIPT_REASON,  "PR_NON_RECEIPT_REASON",
    PR_RECEIVED_BY_ENTRYID, "PR_RECEIVED_BY_ENTRYID",
    PR_RECEIVED_BY_NAME,    "PR_RECEIVED_BY_NAME",
    PR_SENT_REPRESENTING_ENTRYID,   "PR_SENT_REPRESENTING_ENTRYID",
    PR_SENT_REPRESENTING_NAME,  "PR_SENT_REPRESENTING_NAME",
    PR_RCVD_REPRESENTING_ENTRYID,   "PR_RCVD_REPRESENTING_ENTRYID",
    PR_RCVD_REPRESENTING_NAME,  "PR_RCVD_REPRESENTING_NAME",
    PR_REPORT_ENTRYID,  "PR_REPORT_ENTRYID",
    PR_READ_RECEIPT_ENTRYID,    "PR_READ_RECEIPT_ENTRYID",
    PR_MESSAGE_SUBMISSION_ID,   "PR_MESSAGE_SUBMISSION_ID",
    PR_PROVIDER_SUBMIT_TIME,    "PR_PROVIDER_SUBMIT_TIME",
    PR_ORIGINAL_SUBJECT,    "PR_ORIGINAL_SUBJECT",
    PR_DISC_VAL,    "PR_DISC_VAL",
    PR_ORIG_MESSAGE_CLASS,  "PR_ORIG_MESSAGE_CLASS",
    PR_ORIGINAL_AUTHOR_ENTRYID, "PR_ORIGINAL_AUTHOR_ENTRYID",
    PR_ORIGINAL_AUTHOR_NAME,    "PR_ORIGINAL_AUTHOR_NAME",
    PR_ORIGINAL_SUBMIT_TIME,    "PR_ORIGINAL_SUBMIT_TIME",
    PR_REPLY_RECIPIENT_ENTRIES, "PR_REPLY_RECIPIENT_ENTRIES",
    PR_REPLY_RECIPIENT_NAMES,   "PR_REPLY_RECIPIENT_NAMES",
    PR_RECEIVED_BY_SEARCH_KEY,  "PR_RECEIVED_BY_SEARCH_KEY",
    PR_RCVD_REPRESENTING_SEARCH_KEY,    "PR_RCVD_REPRESENTING_SEARCH_KEY",
    PR_READ_RECEIPT_SEARCH_KEY, "PR_READ_RECEIPT_SEARCH_KEY",
    PR_REPORT_SEARCH_KEY,   "PR_REPORT_SEARCH_KEY",
    PR_ORIGINAL_DELIVERY_TIME,  "PR_ORIGINAL_DELIVERY_TIME",
    PR_ORIGINAL_AUTHOR_SEARCH_KEY,  "PR_ORIGINAL_AUTHOR_SEARCH_KEY",
    PR_MESSAGE_TO_ME,   "PR_MESSAGE_TO_ME",
    PR_MESSAGE_CC_ME,   "PR_MESSAGE_CC_ME",
    PR_MESSAGE_RECIP_ME,    "PR_MESSAGE_RECIP_ME",
    PR_ORIGINAL_SENDER_NAME,    "PR_ORIGINAL_SENDER_NAME",
    PR_ORIGINAL_SENDER_ENTRYID, "PR_ORIGINAL_SENDER_ENTRYID",
    PR_ORIGINAL_SENDER_SEARCH_KEY,  "PR_ORIGINAL_SENDER_SEARCH_KEY",
    PR_ORIGINAL_SENT_REPRESENTING_NAME, "PR_ORIGINAL_SENT_REPRESENTING_NAME",
    PR_ORIGINAL_SENT_REPRESENTING_ENTRYID,  "PR_ORIGINAL_SENT_REPRESENTING_ENTRYID",
    PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY,   "PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY",
    PR_START_DATE,  "PR_START_DATE",
    PR_END_DATE,    "PR_END_DATE",
    PR_OWNER_APPT_ID,   "PR_OWNER_APPT_ID",
    PR_RESPONSE_REQUESTED,  "PR_RESPONSE_REQUESTED",
    PR_SENT_REPRESENTING_ADDRTYPE,  "PR_SENT_REPRESENTING_ADDRTYPE",
    PR_SENT_REPRESENTING_EMAIL_ADDRESS, "PR_SENT_REPRESENTING_EMAIL_ADDRESS",
    PR_ORIGINAL_SENDER_ADDRTYPE,    "PR_ORIGINAL_SENDER_ADDRTYPE",
    PR_ORIGINAL_SENDER_EMAIL_ADDRESS,   "PR_ORIGINAL_SENDER_EMAIL_ADDRESS",
    PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE, "PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE",
    PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS,    "PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS",
    PR_CONVERSATION_TOPIC,  "PR_CONVERSATION_TOPIC",
    PR_CONVERSATION_INDEX,  "PR_CONVERSATION_INDEX",
    PR_BODY,    "PR_BODY",
    PR_REPORT_TEXT, "PR_REPORT_TEXT",
    PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY, "PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY",
    PR_REPORTING_DL_NAME,   "PR_REPORTING_DL_NAME",
    PR_REPORTING_MTA_CERTIFICATE,   "PR_REPORTING_MTA_CERTIFICATE",
    PR_RTF_SYNC_BODY_CRC,   "PR_RTF_SYNC_BODY_CRC",
    PR_RTF_SYNC_BODY_COUNT, "PR_RTF_SYNC_BODY_COUNT",
    PR_RTF_SYNC_BODY_TAG,   "PR_RTF_SYNC_BODY_TAG",
    PR_RTF_COMPRESSED,  "PR_RTF_COMPRESSED",
    PR_RTF_SYNC_PREFIX_COUNT,   "PR_RTF_SYNC_PREFIX_COUNT",
    PR_RTF_SYNC_TRAILING_COUNT, "PR_RTF_SYNC_TRAILING_COUNT",
    PR_ORIGINALLY_INTENDED_RECIP_ENTRYID,   "PR_ORIGINALLY_INTENDED_RECIP_ENTRYID",
    PR_PREPROCESS,  "PR_PREPROCESS",
    PR_CONTENT_INTEGRITY_CHECK, "PR_CONTENT_INTEGRITY_CHECK",
    PR_EXPLICIT_CONVERSION, "PR_EXPLICIT_CONVERSION",
    PR_IPM_RETURN_REQUESTED,    "PR_IPM_RETURN_REQUESTED",
    PR_MESSAGE_TOKEN,   "PR_MESSAGE_TOKEN",
    PR_NDR_REASON_CODE, "PR_NDR_REASON_CODE",
    PR_NDR_DIAG_CODE,   "PR_NDR_DIAG_CODE",
    PR_NON_RECEIPT_NOTIFICATION_REQUESTED,  "PR_NON_RECEIPT_NOTIFICATION_REQUESTED",
    PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED,    "PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED",
    PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT,    "PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT",
    PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY,   "PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY",
    PR_PHYSICAL_DELIVERY_MODE,  "PR_PHYSICAL_DELIVERY_MODE",
    PR_PHYSICAL_DELIVERY_REPORT_REQUEST,    "PR_PHYSICAL_DELIVERY_REPORT_REQUEST",
    PR_PHYSICAL_FORWARDING_ADDRESS, "PR_PHYSICAL_FORWARDING_ADDRESS",
    PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED,   "PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED",
    PR_PHYSICAL_FORWARDING_PROHIBITED,  "PR_PHYSICAL_FORWARDING_PROHIBITED",
    PR_PHYSICAL_RENDITION_ATTRIBUTES,   "PR_PHYSICAL_RENDITION_ATTRIBUTES",
    PR_PROOF_OF_DELIVERY,   "PR_PROOF_OF_DELIVERY",
    PR_PROOF_OF_DELIVERY_REQUESTED, "PR_PROOF_OF_DELIVERY_REQUESTED",
    PR_RECIPIENT_CERTIFICATE,   "PR_RECIPIENT_CERTIFICATE",
    PR_RECIPIENT_NUMBER_FOR_ADVICE, "PR_RECIPIENT_NUMBER_FOR_ADVICE",
    PR_RECIPIENT_TYPE,  "PR_RECIPIENT_TYPE",
    PR_REGISTERED_MAIL_TYPE,    "PR_REGISTERED_MAIL_TYPE",
    PR_REPLY_REQUESTED, "PR_REPLY_REQUESTED",
    PR_REQUESTED_DELIVERY_METHOD,   "PR_REQUESTED_DELIVERY_METHOD",
    PR_SENDER_ENTRYID,  "PR_SENDER_ENTRYID",
    PR_SENDER_NAME, "PR_SENDER_NAME",
    PR_TYPE_OF_MTS_USER,    "PR_TYPE_OF_MTS_USER",
    PR_SENDER_SEARCH_KEY,   "PR_SENDER_SEARCH_KEY",
    PR_SENDER_ADDRTYPE, "PR_SENDER_ADDRTYPE",
    PR_SENDER_EMAIL_ADDRESS,    "PR_SENDER_EMAIL_ADDRESS",
    PR_CURRENT_VERSION, "PR_CURRENT_VERSION",
    PR_DELETE_AFTER_SUBMIT, "PR_DELETE_AFTER_SUBMIT",
    PR_DISPLAY_BCC, "PR_DISPLAY_BCC",
    PR_DISPLAY_CC,  "PR_DISPLAY_CC",
    PR_DISPLAY_TO,  "PR_DISPLAY_TO",
    PR_PARENT_DISPLAY,  "PR_PARENT_DISPLAY",
    PR_MESSAGE_DELIVERY_TIME,   "PR_MESSAGE_DELIVERY_TIME",
    PR_MESSAGE_FLAGS,   "PR_MESSAGE_FLAGS",
    PR_MESSAGE_SIZE,    "PR_MESSAGE_SIZE",
    PR_PARENT_ENTRYID,  "PR_PARENT_ENTRYID",
    PR_SENTMAIL_ENTRYID,    "PR_SENTMAIL_ENTRYID",
    PR_CORRELATE,   "PR_CORRELATE",
    PR_CORRELATE_MTSID, "PR_CORRELATE_MTSID",
    PR_DISCRETE_VALUES, "PR_DISCRETE_VALUES",
    PR_RESPONSIBILITY,  "PR_RESPONSIBILITY",
    PR_SPOOLER_STATUS,  "PR_SPOOLER_STATUS",
    PR_TRANSPORT_STATUS,    "PR_TRANSPORT_STATUS",
    PR_MESSAGE_RECIPIENTS,  "PR_MESSAGE_RECIPIENTS",
    PR_MESSAGE_ATTACHMENTS, "PR_MESSAGE_ATTACHMENTS",
    PR_SUBMIT_FLAGS,    "PR_SUBMIT_FLAGS",
    PR_TRANSPORT_KEY,   "PR_TRANSPORT_KEY",
    PR_MSG_STATUS,  "PR_MSG_STATUS",
    PR_MESSAGE_DOWNLOAD_TIME,   "PR_MESSAGE_DOWNLOAD_TIME",
    PR_CREATION_VERSION,    "PR_CREATION_VERSION",
    PR_MODIFY_VERSION,  "PR_MODIFY_VERSION",
    PR_HASATTACH,   "PR_HASATTACH",
    PR_BODY_CRC,    "PR_BODY_CRC",
    PR_NORMALIZED_SUBJECT,  "PR_NORMALIZED_SUBJECT",
    PR_RTF_IN_SYNC, "PR_RTF_IN_SYNC",
    PR_ATTACH_SIZE, "PR_ATTACH_SIZE",
    PR_ATTACH_NUM,  "PR_ATTACH_NUM",
    PR_ORIGINAL_DISPLAY_BCC,    "PR_ORIGINAL_DISPLAY_BCC",
    PR_ORIGINAL_DISPLAY_CC, "PR_ORIGINAL_DISPLAY_CC",
    PR_ORIGINAL_DISPLAY_TO, "PR_ORIGINAL_DISPLAY_TO",
    PR_ENTRYID, "PR_ENTRYID",
    PR_OBJECT_TYPE, "PR_OBJECT_TYPE",
    PR_ICON,    "PR_ICON",
    PR_MINI_ICON,   "PR_MINI_ICON",
    PR_STORE_ENTRYID,   "PR_STORE_ENTRYID",
    PR_STORE_RECORD_KEY,    "PR_STORE_RECORD_KEY",
    PR_RECORD_KEY,  "PR_RECORD_KEY",
    PR_MAPPING_SIGNATURE,   "PR_MAPPING_SIGNATURE",
    PR_ACCESS_LEVEL,    "PR_ACCESS_LEVEL",
    PR_INSTANCE_KEY,    "PR_INSTANCE_KEY",
    PR_ROW_TYPE,    "PR_ROW_TYPE",
    PR_ACCESS,  "PR_ACCESS",
    PR_ROWID,   "PR_ROWID",
    PR_DISPLAY_NAME,    "PR_DISPLAY_NAME",
    PR_ADDRTYPE,    "PR_ADDRTYPE",
    PR_EMAIL_ADDRESS,   "PR_EMAIL_ADDRESS",
    PR_COMMENT, "PR_COMMENT",
    PR_DEPTH,   "PR_DEPTH",
    PR_PROVIDER_DISPLAY,    "PR_PROVIDER_DISPLAY",
    PR_CREATION_TIME,   "PR_CREATION_TIME",
    PR_LAST_MODIFICATION_TIME,  "PR_LAST_MODIFICATION_TIME",
    PR_RESOURCE_FLAGS,  "PR_RESOURCE_FLAGS",
    PR_PROVIDER_DLL_NAME,   "PR_PROVIDER_DLL_NAME",
    PR_SEARCH_KEY,  "PR_SEARCH_KEY",
    PR_PROVIDER_UID,    "PR_PROVIDER_UID",
    PR_PROVIDER_ORDINAL,    "PR_PROVIDER_ORDINAL",
    PR_FORM_VERSION,    "PR_FORM_VERSION",
    PR_FORM_CLSID,  "PR_FORM_CLSID",
    PR_FORM_CONTACT_NAME,   "PR_FORM_CONTACT_NAME",
    PR_FORM_CATEGORY,   "PR_FORM_CATEGORY",
    PR_FORM_CATEGORY_SUB,   "PR_FORM_CATEGORY_SUB",
    PR_FORM_HOST_MAP,   "PR_FORM_HOST_MAP",
    PR_FORM_HIDDEN, "PR_FORM_HIDDEN",
    PR_FORM_DESIGNER_NAME,  "PR_FORM_DESIGNER_NAME",
    PR_FORM_DESIGNER_GUID,  "PR_FORM_DESIGNER_GUID",
    PR_FORM_MESSAGE_BEHAVIOR,   "PR_FORM_MESSAGE_BEHAVIOR",
    PR_DEFAULT_STORE,   "PR_DEFAULT_STORE",
    PR_STORE_SUPPORT_MASK,  "PR_STORE_SUPPORT_MASK",
    PR_IPM_SUBTREE_SEARCH_KEY,  "PR_IPM_SUBTREE_SEARCH_KEY",
    PR_IPM_OUTBOX_SEARCH_KEY,   "PR_IPM_OUTBOX_SEARCH_KEY",
    PR_IPM_WASTEBASKET_SEARCH_KEY,  "PR_IPM_WASTEBASKET_SEARCH_KEY",
    PR_IPM_SENTMAIL_SEARCH_KEY, "PR_IPM_SENTMAIL_SEARCH_KEY",
    PR_MDB_PROVIDER,    "PR_MDB_PROVIDER",
    PR_RECEIVE_FOLDER_SETTINGS, "PR_RECEIVE_FOLDER_SETTINGS",
    PR_VALID_FOLDER_MASK,   "PR_VALID_FOLDER_MASK",
    PR_IPM_SUBTREE_ENTRYID, "PR_IPM_SUBTREE_ENTRYID",
    PR_IPM_OUTBOX_ENTRYID,  "PR_IPM_OUTBOX_ENTRYID",
    PR_IPM_WASTEBASKET_ENTRYID, "PR_IPM_WASTEBASKET_ENTRYID",
    PR_IPM_SENTMAIL_ENTRYID,    "PR_IPM_SENTMAIL_ENTRYID",
    PR_VIEWS_ENTRYID,   "PR_VIEWS_ENTRYID",
    PR_COMMON_VIEWS_ENTRYID,    "PR_COMMON_VIEWS_ENTRYID",
    PR_FINDER_ENTRYID,  "PR_FINDER_ENTRYID",
    PR_CONTAINER_FLAGS, "PR_CONTAINER_FLAGS",
    PR_FOLDER_TYPE, "PR_FOLDER_TYPE",
    PR_CONTENT_COUNT,   "PR_CONTENT_COUNT",
    PR_CONTENT_UNREAD,  "PR_CONTENT_UNREAD",
    PR_CREATE_TEMPLATES,    "PR_CREATE_TEMPLATES",
    PR_DETAILS_TABLE,   "PR_DETAILS_TABLE",
    PR_SEARCH,  "PR_SEARCH",
    PR_SELECTABLE,  "PR_SELECTABLE",
    PR_SUBFOLDERS,  "PR_SUBFOLDERS",
    PR_STATUS,  "PR_STATUS",
    PR_ANR, "PR_ANR",
    PR_CONTENTS_SORT_ORDER, "PR_CONTENTS_SORT_ORDER",
    PR_CONTAINER_HIERARCHY, "PR_CONTAINER_HIERARCHY",
    PR_CONTAINER_CONTENTS,  "PR_CONTAINER_CONTENTS",
    PR_FOLDER_ASSOCIATED_CONTENTS,  "PR_FOLDER_ASSOCIATED_CONTENTS",
    PR_DEF_CREATE_DL,   "PR_DEF_CREATE_DL",
    PR_DEF_CREATE_MAILUSER, "PR_DEF_CREATE_MAILUSER",
    PR_CONTAINER_CLASS, "PR_CONTAINER_CLASS",
    PR_CONTAINER_MODIFY_VERSION,    "PR_CONTAINER_MODIFY_VERSION",
    PR_AB_PROVIDER_ID,  "PR_AB_PROVIDER_ID",
    PR_ATTACHMENT_X400_PARAMETERS,  "PR_ATTACHMENT_X400_PARAMETERS",
    PR_ATTACH_DATA_BIN, "PR_ATTACH_DATA_BIN",
    PR_ATTACH_DATA_OBJ, "PR_ATTACH_DATA_OBJ",
    PR_ATTACH_ENCODING, "PR_ATTACH_ENCODING",
    PR_ATTACH_EXTENSION,    "PR_ATTACH_EXTENSION",
    PR_ATTACH_FILENAME, "PR_ATTACH_FILENAME",
    PR_ATTACH_METHOD,   "PR_ATTACH_METHOD",
    PR_ATTACH_LONG_FILENAME,    "PR_ATTACH_LONG_FILENAME",
    PR_ATTACH_PATHNAME, "PR_ATTACH_PATHNAME",
    PR_ATTACH_RENDERING,    "PR_ATTACH_RENDERING",
    PR_ATTACH_TAG,  "PR_ATTACH_TAG",
    PR_RENDERING_POSITION,  "PR_RENDERING_POSITION",
    PR_ATTACH_TRANSPORT_NAME,   "PR_ATTACH_TRANSPORT_NAME",
    PR_DISPLAY_TYPE,    "PR_DISPLAY_TYPE",
    PR_TEMPLATEID,  "PR_TEMPLATEID",
    PR_PRIMARY_CAPABILITY,  "PR_PRIMARY_CAPABILITY",
    PR_ACCOUNT, "PR_ACCOUNT",
    PR_ALTERNATE_RECIPIENT, "PR_ALTERNATE_RECIPIENT",
    PR_CALLBACK_TELEPHONE_NUMBER,   "PR_CALLBACK_TELEPHONE_NUMBER",
    PR_CONVERSION_PROHIBITED,   "PR_CONVERSION_PROHIBITED",
    PR_DISCLOSE_RECIPIENTS, "PR_DISCLOSE_RECIPIENTS",
    PR_GENERATION,  "PR_GENERATION",
    PR_GIVEN_NAME,  "PR_GIVEN_NAME",
    PR_GOVERNMENT_ID_NUMBER,    "PR_GOVERNMENT_ID_NUMBER",
    PR_OFFICE_TELEPHONE_NUMBER, "PR_OFFICE_TELEPHONE_NUMBER",
    PR_HOME_TELEPHONE_NUMBER,   "PR_HOME_TELEPHONE_NUMBER",
    PR_INITIALS,    "PR_INITIALS",
    PR_KEYWORD, "PR_KEYWORD",
    PR_LANGUAGE,    "PR_LANGUAGE",
    PR_LOCATION,    "PR_LOCATION",
    PR_MAIL_PERMISSION, "PR_MAIL_PERMISSION",
    PR_MHS_COMMON_NAME, "PR_MHS_COMMON_NAME",
    PR_ORGANIZATIONAL_ID_NUMBER,    "PR_ORGANIZATIONAL_ID_NUMBER",
    PR_SURNAME, "PR_SURNAME",
    PR_ORIGINAL_ENTRYID,    "PR_ORIGINAL_ENTRYID",
    PR_ORIGINAL_DISPLAY_NAME,   "PR_ORIGINAL_DISPLAY_NAME",
    PR_ORIGINAL_SEARCH_KEY, "PR_ORIGINAL_SEARCH_KEY",
    PR_POSTAL_ADDRESS,  "PR_POSTAL_ADDRESS",
    PR_COMPANY_NAME,    "PR_COMPANY_NAME",
    PR_TITLE,   "PR_TITLE",
    PR_DEPARTMENT_NAME, "PR_DEPARTMENT_NAME",
    PR_OFFICE_LOCATION, "PR_OFFICE_LOCATION",
    PR_PRIMARY_TELEPHONE_NUMBER,    "PR_PRIMARY_TELEPHONE_NUMBER",
    PR_OFFICE2_TELEPHONE_NUMBER,    "PR_OFFICE2_TELEPHONE_NUMBER",
    PR_CELLULAR_TELEPHONE_NUMBER,   "PR_CELLULAR_TELEPHONE_NUMBER",
    PR_RADIO_TELEPHONE_NUMBER,  "PR_RADIO_TELEPHONE_NUMBER",
    PR_CAR_TELEPHONE_NUMBER,    "PR_CAR_TELEPHONE_NUMBER",
    PR_OTHER_TELEPHONE_NUMBER,  "PR_OTHER_TELEPHONE_NUMBER",
    PR_TRANSMITABLE_DISPLAY_NAME,   "PR_TRANSMITABLE_DISPLAY_NAME",
    PR_STORE_PROVIDERS, "PR_STORE_PROVIDERS",
    PR_AB_PROVIDERS,    "PR_AB_PROVIDERS",
    PR_TRANSPORT_PROVIDERS, "PR_TRANSPORT_PROVIDERS",
    PR_DEFAULT_PROFILE, "PR_DEFAULT_PROFILE",
    PR_AB_SEARCH_PATH,  "PR_AB_SEARCH_PATH",
    PR_AB_DEFAULT_DIR,  "PR_AB_DEFAULT_DIR",
    PR_AB_DEFAULT_PAB,  "PR_AB_DEFAULT_PAB",
    PR_FILTERING_HOOKS, "PR_FILTERING_HOOKS",
    PR_SERVICE_NAME,    "PR_SERVICE_NAME",
    PR_SERVICE_DLL_NAME,    "PR_SERVICE_DLL_NAME",
    PR_SERVICE_ENTRY_NAME,  "PR_SERVICE_ENTRY_NAME",
    PR_SERVICE_UID, "PR_SERVICE_UID",
    PR_SERVICE_EXTRA_UIDS,  "PR_SERVICE_EXTRA_UIDS",
    PR_SERVICES,    "PR_SERVICES",
    PR_SERVICE_SUPPORT_FILES,   "PR_SERVICE_SUPPORT_FILES",
    PR_SERVICE_DELETE_FILES,    "PR_SERVICE_DELETE_FILES",
    PR_IDENTITY_DISPLAY,    "PR_IDENTITY_DISPLAY",
    PR_IDENTITY_ENTRYID,    "PR_IDENTITY_ENTRYID",
    PR_RESOURCE_METHODS,    "PR_RESOURCE_METHODS",
    PR_RESOURCE_TYPE,   "PR_RESOURCE_TYPE",
    PR_STATUS_CODE, "PR_STATUS_CODE",
    PR_IDENTITY_SEARCH_KEY, "PR_IDENTITY_SEARCH_KEY",
    PR_OWN_STORE_ENTRYID,   "PR_OWN_STORE_ENTRYID",
    PR_RESOURCE_PATH,   "PR_RESOURCE_PATH",
    PR_STATUS_STRING,   "PR_STATUS_STRING",
    PR_X400_DEFERRED_DELIVERY_CANCEL,   "PR_X400_DEFERRED_DELIVERY_CANCEL",
    PR_HEADER_FOLDER_ENTRYID,   "PR_HEADER_FOLDER_ENTRYID",
    PR_REMOTE_PROGRESS, "PR_REMOTE_PROGRESS",
    PR_REMOTE_PROGRESS_TEXT,    "PR_REMOTE_PROGRESS_TEXT",
    PR_CONTROL_FLAGS,   "PR_CONTROL_FLAGS",
    PR_CONTROL_STRUCTURE,   "PR_CONTROL_STRUCTURE",
    PR_CONTROL_TYPE,    "PR_CONTROL_TYPE",
    PR_DELTAX,  "PR_DELTAX",
    PR_DELTAY,  "PR_DELTAY",
    PR_XPOS,    "PR_XPOS",
    PR_YPOS,    "PR_YPOS",
    PR_CONTROL_ID,  "PR_CONTROL_ID",
    PR_INITIAL_DETAILS_PANE,    "PR_INITIAL_DETAILS_PANE"
};

/* Data for table: PropIDs */

static ENTRY s4[338] = 
{
    PROP_ID(PR_ACKNOWLEDGEMENT_MODE),   "PR_ACKNOWLEDGEMENT_MODE",
    PROP_ID(PR_ALTERNATE_RECIPIENT_ALLOWED),    "PR_ALTERNATE_RECIPIENT_ALLOWED",
    PROP_ID(PR_AUTHORIZING_USERS),  "PR_AUTHORIZING_USERS",
    PROP_ID(PR_AUTO_FORWARD_COMMENT),   "PR_AUTO_FORWARD_COMMENT",
    PROP_ID(PR_AUTO_FORWARDED), "PR_AUTO_FORWARDED",
    PROP_ID(PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID),   "PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID",
    PROP_ID(PR_CONTENT_CORRELATOR), "PR_CONTENT_CORRELATOR",
    PROP_ID(PR_CONTENT_IDENTIFIER), "PR_CONTENT_IDENTIFIER",
    PROP_ID(PR_CONTENT_LENGTH), "PR_CONTENT_LENGTH",
    PROP_ID(PR_CONTENT_RETURN_REQUESTED),   "PR_CONTENT_RETURN_REQUESTED",
    PROP_ID(PR_CONVERSATION_KEY),   "PR_CONVERSATION_KEY",
    PROP_ID(PR_CONVERSION_EITS),    "PR_CONVERSION_EITS",
    PROP_ID(PR_CONVERSION_WITH_LOSS_PROHIBITED),    "PR_CONVERSION_WITH_LOSS_PROHIBITED",
    PROP_ID(PR_CONVERTED_EITS), "PR_CONVERTED_EITS",
    PROP_ID(PR_DEFERRED_DELIVERY_TIME), "PR_DEFERRED_DELIVERY_TIME",
    PROP_ID(PR_DELIVER_TIME),   "PR_DELIVER_TIME",
    PROP_ID(PR_DISCARD_REASON), "PR_DISCARD_REASON",
    PROP_ID(PR_DISCLOSURE_OF_RECIPIENTS),   "PR_DISCLOSURE_OF_RECIPIENTS",
    PROP_ID(PR_DL_EXPANSION_HISTORY),   "PR_DL_EXPANSION_HISTORY",
    PROP_ID(PR_DL_EXPANSION_PROHIBITED),    "PR_DL_EXPANSION_PROHIBITED",
    PROP_ID(PR_EXPIRY_TIME),    "PR_EXPIRY_TIME",
    PROP_ID(PR_IMPLICIT_CONVERSION_PROHIBITED), "PR_IMPLICIT_CONVERSION_PROHIBITED",
    PROP_ID(PR_IMPORTANCE), "PR_IMPORTANCE",
    PROP_ID(PR_IPM_ID), "PR_IPM_ID",
    PROP_ID(PR_LATEST_DELIVERY_TIME),   "PR_LATEST_DELIVERY_TIME",
    PROP_ID(PR_MESSAGE_CLASS),  "PR_MESSAGE_CLASS",
    PROP_ID(PR_MESSAGE_DELIVERY_ID),    "PR_MESSAGE_DELIVERY_ID",
    PROP_ID(PR_MESSAGE_SECURITY_LABEL), "PR_MESSAGE_SECURITY_LABEL",
    PROP_ID(PR_OBSOLETED_IPMS), "PR_OBSOLETED_IPMS",
    PROP_ID(PR_ORIGINALLY_INTENDED_RECIPIENT_NAME), "PR_ORIGINALLY_INTENDED_RECIPIENT_NAME",
    PROP_ID(PR_ORIGINAL_EITS),  "PR_ORIGINAL_EITS",
    PROP_ID(PR_ORIGINATOR_CERTIFICATE), "PR_ORIGINATOR_CERTIFICATE",
    PROP_ID(PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED),   "PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED",
    PROP_ID(PR_ORIGINATOR_RETURN_ADDRESS),  "PR_ORIGINATOR_RETURN_ADDRESS",
    PROP_ID(PR_PARENT_KEY), "PR_PARENT_KEY",
    PROP_ID(PR_PRIORITY),   "PR_PRIORITY",
    PROP_ID(PR_PROOF_OF_SUBMISSION_REQUESTED),  "PR_PROOF_OF_SUBMISSION_REQUESTED",
    PROP_ID(PR_READ_RECEIPT_REQUESTED), "PR_READ_RECEIPT_REQUESTED",
    PROP_ID(PR_RECEIPT_TIME),   "PR_RECEIPT_TIME",
    PROP_ID(PR_RECIPIENT_REASSIGNMENT_PROHIBITED),  "PR_RECIPIENT_REASSIGNMENT_PROHIBITED",
    PROP_ID(PR_REDIRECTION_HISTORY),    "PR_REDIRECTION_HISTORY",
    PROP_ID(PR_RELATED_IPMS),   "PR_RELATED_IPMS",
    PROP_ID(PR_LANGUAGES),  "PR_LANGUAGES",
    PROP_ID(PR_REPLY_TIME), "PR_REPLY_TIME",
    PROP_ID(PR_REPORT_TAG), "PR_REPORT_TAG",
    PROP_ID(PR_REPORT_TIME),    "PR_REPORT_TIME",
    PROP_ID(PR_RETURNED_IPM),   "PR_RETURNED_IPM",
    PROP_ID(PR_SECURITY),   "PR_SECURITY",
    PROP_ID(PR_INCOMPLETE_COPY),    "PR_INCOMPLETE_COPY",
    PROP_ID(PR_SENSITIVITY),    "PR_SENSITIVITY",
    PROP_ID(PR_SUBJECT),    "PR_SUBJECT",
    PROP_ID(PR_SUBJECT_IPM),    "PR_SUBJECT_IPM",
    PROP_ID(PR_CLIENT_SUBMIT_TIME), "PR_CLIENT_SUBMIT_TIME",
    PROP_ID(PR_REPORT_NAME),    "PR_REPORT_NAME",
    PROP_ID(PR_SENT_REPRESENTING_SEARCH_KEY),   "PR_SENT_REPRESENTING_SEARCH_KEY",
    PROP_ID(PR_X400_CONTENT_TYPE),  "PR_X400_CONTENT_TYPE",
    PROP_ID(PR_NON_RECEIPT_REASON), "PR_NON_RECEIPT_REASON",
    PROP_ID(PR_RECEIVED_BY_ENTRYID),    "PR_RECEIVED_BY_ENTRYID",
    PROP_ID(PR_RECEIVED_BY_NAME),   "PR_RECEIVED_BY_NAME",
    PROP_ID(PR_SENT_REPRESENTING_ENTRYID),  "PR_SENT_REPRESENTING_ENTRYID",
    PROP_ID(PR_SENT_REPRESENTING_NAME), "PR_SENT_REPRESENTING_NAME",
    PROP_ID(PR_RCVD_REPRESENTING_ENTRYID),  "PR_RCVD_REPRESENTING_ENTRYID",
    PROP_ID(PR_RCVD_REPRESENTING_NAME), "PR_RCVD_REPRESENTING_NAME",
    PROP_ID(PR_REPORT_ENTRYID), "PR_REPORT_ENTRYID",
    PROP_ID(PR_READ_RECEIPT_ENTRYID),   "PR_READ_RECEIPT_ENTRYID",
    PROP_ID(PR_MESSAGE_SUBMISSION_ID),  "PR_MESSAGE_SUBMISSION_ID",
    PROP_ID(PR_PROVIDER_SUBMIT_TIME),   "PR_PROVIDER_SUBMIT_TIME",
    PROP_ID(PR_ORIGINAL_SUBJECT),   "PR_ORIGINAL_SUBJECT",
    PROP_ID(PR_DISC_VAL),   "PR_DISC_VAL",
    PROP_ID(PR_ORIG_MESSAGE_CLASS), "PR_ORIG_MESSAGE_CLASS",
    PROP_ID(PR_ORIGINAL_AUTHOR_ENTRYID),    "PR_ORIGINAL_AUTHOR_ENTRYID",
    PROP_ID(PR_ORIGINAL_AUTHOR_NAME),   "PR_ORIGINAL_AUTHOR_NAME",
    PROP_ID(PR_ORIGINAL_SUBMIT_TIME),   "PR_ORIGINAL_SUBMIT_TIME",
    PROP_ID(PR_REPLY_RECIPIENT_ENTRIES),    "PR_REPLY_RECIPIENT_ENTRIES",
    PROP_ID(PR_REPLY_RECIPIENT_NAMES),  "PR_REPLY_RECIPIENT_NAMES",
    PROP_ID(PR_RECEIVED_BY_SEARCH_KEY), "PR_RECEIVED_BY_SEARCH_KEY",
    PROP_ID(PR_RCVD_REPRESENTING_SEARCH_KEY),   "PR_RCVD_REPRESENTING_SEARCH_KEY",
    PROP_ID(PR_READ_RECEIPT_SEARCH_KEY),    "PR_READ_RECEIPT_SEARCH_KEY",
    PROP_ID(PR_REPORT_SEARCH_KEY),  "PR_REPORT_SEARCH_KEY",
    PROP_ID(PR_ORIGINAL_DELIVERY_TIME), "PR_ORIGINAL_DELIVERY_TIME",
    PROP_ID(PR_ORIGINAL_AUTHOR_SEARCH_KEY), "PR_ORIGINAL_AUTHOR_SEARCH_KEY",
    PROP_ID(PR_MESSAGE_TO_ME),  "PR_MESSAGE_TO_ME",
    PROP_ID(PR_MESSAGE_CC_ME),  "PR_MESSAGE_CC_ME",
    PROP_ID(PR_MESSAGE_RECIP_ME),   "PR_MESSAGE_RECIP_ME",
    PROP_ID(PR_ORIGINAL_SENDER_NAME),   "PR_ORIGINAL_SENDER_NAME",
    PROP_ID(PR_ORIGINAL_SENDER_ENTRYID),    "PR_ORIGINAL_SENDER_ENTRYID",
    PROP_ID(PR_ORIGINAL_SENDER_SEARCH_KEY), "PR_ORIGINAL_SENDER_SEARCH_KEY",
    PROP_ID(PR_ORIGINAL_SENT_REPRESENTING_NAME),    "PR_ORIGINAL_SENT_REPRESENTING_NAME",
    PROP_ID(PR_ORIGINAL_SENT_REPRESENTING_ENTRYID), "PR_ORIGINAL_SENT_REPRESENTING_ENTRYID",
    PROP_ID(PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY),  "PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY",
    PROP_ID(PR_START_DATE), "PR_START_DATE",
    PROP_ID(PR_END_DATE),   "PR_END_DATE",
    PROP_ID(PR_OWNER_APPT_ID),  "PR_OWNER_APPT_ID",
    PROP_ID(PR_RESPONSE_REQUESTED), "PR_RESPONSE_REQUESTED",
    PROP_ID(PR_SENT_REPRESENTING_ADDRTYPE), "PR_SENT_REPRESENTING_ADDRTYPE",
    PROP_ID(PR_SENT_REPRESENTING_EMAIL_ADDRESS),    "PR_SENT_REPRESENTING_EMAIL_ADDRESS",
    PROP_ID(PR_ORIGINAL_SENDER_ADDRTYPE),   "PR_ORIGINAL_SENDER_ADDRTYPE",
    PROP_ID(PR_ORIGINAL_SENDER_EMAIL_ADDRESS),  "PR_ORIGINAL_SENDER_EMAIL_ADDRESS",
    PROP_ID(PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE),    "PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE",
    PROP_ID(PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS),   "PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS",
    PROP_ID(PR_CONVERSATION_TOPIC), "PR_CONVERSATION_TOPIC",
    PROP_ID(PR_CONVERSATION_INDEX), "PR_CONVERSATION_INDEX",
    PROP_ID(PR_BODY),   "PR_BODY",
    PROP_ID(PR_REPORT_TEXT),    "PR_REPORT_TEXT",
    PROP_ID(PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY),    "PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY",
    PROP_ID(PR_REPORTING_DL_NAME),  "PR_REPORTING_DL_NAME",
    PROP_ID(PR_REPORTING_MTA_CERTIFICATE),  "PR_REPORTING_MTA_CERTIFICATE",
    PROP_ID(PR_RTF_SYNC_BODY_CRC),  "PR_RTF_SYNC_BODY_CRC",
    PROP_ID(PR_RTF_SYNC_BODY_COUNT),    "PR_RTF_SYNC_BODY_COUNT",
    PROP_ID(PR_RTF_SYNC_BODY_TAG),  "PR_RTF_SYNC_BODY_TAG",
    PROP_ID(PR_RTF_COMPRESSED), "PR_RTF_COMPRESSED",
    PROP_ID(PR_RTF_SYNC_PREFIX_COUNT),  "PR_RTF_SYNC_PREFIX_COUNT",
    PROP_ID(PR_RTF_SYNC_TRAILING_COUNT),    "PR_RTF_SYNC_TRAILING_COUNT",
    PROP_ID(PR_ORIGINALLY_INTENDED_RECIP_ENTRYID),  "PR_ORIGINALLY_INTENDED_RECIP_ENTRYID",
    PROP_ID(PR_PREPROCESS), "PR_PREPROCESS",
    PROP_ID(PR_CONTENT_INTEGRITY_CHECK),    "PR_CONTENT_INTEGRITY_CHECK",
    PROP_ID(PR_EXPLICIT_CONVERSION),    "PR_EXPLICIT_CONVERSION",
    PROP_ID(PR_IPM_RETURN_REQUESTED),   "PR_IPM_RETURN_REQUESTED",
    PROP_ID(PR_MESSAGE_TOKEN),  "PR_MESSAGE_TOKEN",
    PROP_ID(PR_NDR_REASON_CODE),    "PR_NDR_REASON_CODE",
    PROP_ID(PR_NDR_DIAG_CODE),  "PR_NDR_DIAG_CODE",
    PROP_ID(PR_NON_RECEIPT_NOTIFICATION_REQUESTED), "PR_NON_RECEIPT_NOTIFICATION_REQUESTED",
    PROP_ID(PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED),   "PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED",
    PROP_ID(PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT),   "PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT",
    PROP_ID(PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY),  "PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY",
    PROP_ID(PR_PHYSICAL_DELIVERY_MODE), "PR_PHYSICAL_DELIVERY_MODE",
    PROP_ID(PR_PHYSICAL_DELIVERY_REPORT_REQUEST),   "PR_PHYSICAL_DELIVERY_REPORT_REQUEST",
    PROP_ID(PR_PHYSICAL_FORWARDING_ADDRESS),    "PR_PHYSICAL_FORWARDING_ADDRESS",
    PROP_ID(PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED),  "PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED",
    PROP_ID(PR_PHYSICAL_FORWARDING_PROHIBITED), "PR_PHYSICAL_FORWARDING_PROHIBITED",
    PROP_ID(PR_PHYSICAL_RENDITION_ATTRIBUTES),  "PR_PHYSICAL_RENDITION_ATTRIBUTES",
    PROP_ID(PR_PROOF_OF_DELIVERY),  "PR_PROOF_OF_DELIVERY",
    PROP_ID(PR_PROOF_OF_DELIVERY_REQUESTED),    "PR_PROOF_OF_DELIVERY_REQUESTED",
    PROP_ID(PR_RECIPIENT_CERTIFICATE),  "PR_RECIPIENT_CERTIFICATE",
    PROP_ID(PR_RECIPIENT_NUMBER_FOR_ADVICE),    "PR_RECIPIENT_NUMBER_FOR_ADVICE",
    PROP_ID(PR_RECIPIENT_TYPE), "PR_RECIPIENT_TYPE",
    PROP_ID(PR_REGISTERED_MAIL_TYPE),   "PR_REGISTERED_MAIL_TYPE",
    PROP_ID(PR_REPLY_REQUESTED),    "PR_REPLY_REQUESTED",
    PROP_ID(PR_REQUESTED_DELIVERY_METHOD),  "PR_REQUESTED_DELIVERY_METHOD",
    PROP_ID(PR_SENDER_ENTRYID), "PR_SENDER_ENTRYID",
    PROP_ID(PR_SENDER_NAME),    "PR_SENDER_NAME",
    PROP_ID(PR_TYPE_OF_MTS_USER),   "PR_TYPE_OF_MTS_USER",
    PROP_ID(PR_SENDER_SEARCH_KEY),  "PR_SENDER_SEARCH_KEY",
    PROP_ID(PR_SENDER_ADDRTYPE),    "PR_SENDER_ADDRTYPE",
    PROP_ID(PR_SENDER_EMAIL_ADDRESS),   "PR_SENDER_EMAIL_ADDRESS",
    PROP_ID(PR_CURRENT_VERSION),    "PR_CURRENT_VERSION",
    PROP_ID(PR_DELETE_AFTER_SUBMIT),    "PR_DELETE_AFTER_SUBMIT",
    PROP_ID(PR_DISPLAY_BCC),    "PR_DISPLAY_BCC",
    PROP_ID(PR_DISPLAY_CC), "PR_DISPLAY_CC",
    PROP_ID(PR_DISPLAY_TO), "PR_DISPLAY_TO",
    PROP_ID(PR_PARENT_DISPLAY), "PR_PARENT_DISPLAY",
    PROP_ID(PR_MESSAGE_DELIVERY_TIME),  "PR_MESSAGE_DELIVERY_TIME",
    PROP_ID(PR_MESSAGE_FLAGS),  "PR_MESSAGE_FLAGS",
    PROP_ID(PR_MESSAGE_SIZE),   "PR_MESSAGE_SIZE",
    PROP_ID(PR_PARENT_ENTRYID), "PR_PARENT_ENTRYID",
    PROP_ID(PR_SENTMAIL_ENTRYID),   "PR_SENTMAIL_ENTRYID",
    PROP_ID(PR_CORRELATE),  "PR_CORRELATE",
    PROP_ID(PR_CORRELATE_MTSID),    "PR_CORRELATE_MTSID",
    PROP_ID(PR_DISCRETE_VALUES),    "PR_DISCRETE_VALUES",
    PROP_ID(PR_RESPONSIBILITY), "PR_RESPONSIBILITY",
    PROP_ID(PR_SPOOLER_STATUS), "PR_SPOOLER_STATUS",
    PROP_ID(PR_TRANSPORT_STATUS),   "PR_TRANSPORT_STATUS",
    PROP_ID(PR_MESSAGE_RECIPIENTS), "PR_MESSAGE_RECIPIENTS",
    PROP_ID(PR_MESSAGE_ATTACHMENTS),    "PR_MESSAGE_ATTACHMENTS",
    PROP_ID(PR_SUBMIT_FLAGS),   "PR_SUBMIT_FLAGS",
    PROP_ID(PR_TRANSPORT_KEY),  "PR_TRANSPORT_KEY",
    PROP_ID(PR_MSG_STATUS), "PR_MSG_STATUS",
    PROP_ID(PR_MESSAGE_DOWNLOAD_TIME),  "PR_MESSAGE_DOWNLOAD_TIME",
    PROP_ID(PR_CREATION_VERSION),   "PR_CREATION_VERSION",
    PROP_ID(PR_MODIFY_VERSION), "PR_MODIFY_VERSION",
    PROP_ID(PR_HASATTACH),  "PR_HASATTACH",
    PROP_ID(PR_BODY_CRC),   "PR_BODY_CRC",
    PROP_ID(PR_NORMALIZED_SUBJECT), "PR_NORMALIZED_SUBJECT",
    PROP_ID(PR_RTF_IN_SYNC),    "PR_RTF_IN_SYNC",
    PROP_ID(PR_ATTACH_SIZE),    "PR_ATTACH_SIZE",
    PROP_ID(PR_ATTACH_NUM), "PR_ATTACH_NUM",
    PROP_ID(PR_ORIGINAL_DISPLAY_BCC),   "PR_ORIGINAL_DISPLAY_BCC",
    PROP_ID(PR_ORIGINAL_DISPLAY_CC),    "PR_ORIGINAL_DISPLAY_CC",
    PROP_ID(PR_ORIGINAL_DISPLAY_TO),    "PR_ORIGINAL_DISPLAY_TO",
    PROP_ID(PR_ENTRYID),    "PR_ENTRYID",
    PROP_ID(PR_OBJECT_TYPE),    "PR_OBJECT_TYPE",
    PROP_ID(PR_ICON),   "PR_ICON",
    PROP_ID(PR_MINI_ICON),  "PR_MINI_ICON",
    PROP_ID(PR_STORE_ENTRYID),  "PR_STORE_ENTRYID",
    PROP_ID(PR_STORE_RECORD_KEY),   "PR_STORE_RECORD_KEY",
    PROP_ID(PR_RECORD_KEY), "PR_RECORD_KEY",
    PROP_ID(PR_MAPPING_SIGNATURE),  "PR_MAPPING_SIGNATURE",
    PROP_ID(PR_ACCESS_LEVEL),   "PR_ACCESS_LEVEL",
    PROP_ID(PR_INSTANCE_KEY),   "PR_INSTANCE_KEY",
    PROP_ID(PR_ROW_TYPE),   "PR_ROW_TYPE",
    PROP_ID(PR_ACCESS), "PR_ACCESS",
    PROP_ID(PR_ROWID),  "PR_ROWID",
    PROP_ID(PR_DISPLAY_NAME),   "PR_DISPLAY_NAME",
    PROP_ID(PR_ADDRTYPE),   "PR_ADDRTYPE",
    PROP_ID(PR_EMAIL_ADDRESS),  "PR_EMAIL_ADDRESS",
    PROP_ID(PR_COMMENT),    "PR_COMMENT",
    PROP_ID(PR_DEPTH),  "PR_DEPTH",
    PROP_ID(PR_PROVIDER_DISPLAY),   "PR_PROVIDER_DISPLAY",
    PROP_ID(PR_CREATION_TIME),  "PR_CREATION_TIME",
    PROP_ID(PR_LAST_MODIFICATION_TIME), "PR_LAST_MODIFICATION_TIME",
    PROP_ID(PR_RESOURCE_FLAGS), "PR_RESOURCE_FLAGS",
    PROP_ID(PR_PROVIDER_DLL_NAME),  "PR_PROVIDER_DLL_NAME",
    PROP_ID(PR_SEARCH_KEY), "PR_SEARCH_KEY",
    PROP_ID(PR_PROVIDER_UID),   "PR_PROVIDER_UID",
    PROP_ID(PR_PROVIDER_ORDINAL),   "PR_PROVIDER_ORDINAL",
    PROP_ID(PR_FORM_VERSION),   "PR_FORM_VERSION",
    PROP_ID(PR_FORM_CLSID), "PR_FORM_CLSID",
    PROP_ID(PR_FORM_CONTACT_NAME),  "PR_FORM_CONTACT_NAME",
    PROP_ID(PR_FORM_CATEGORY),  "PR_FORM_CATEGORY",
    PROP_ID(PR_FORM_CATEGORY_SUB),  "PR_FORM_CATEGORY_SUB",
    PROP_ID(PR_FORM_HOST_MAP),  "PR_FORM_HOST_MAP",
    PROP_ID(PR_FORM_HIDDEN),    "PR_FORM_HIDDEN",
    PROP_ID(PR_FORM_DESIGNER_NAME), "PR_FORM_DESIGNER_NAME",
    PROP_ID(PR_FORM_DESIGNER_GUID), "PR_FORM_DESIGNER_GUID",
    PROP_ID(PR_FORM_MESSAGE_BEHAVIOR),  "PR_FORM_MESSAGE_BEHAVIOR",
    PROP_ID(PR_DEFAULT_STORE),  "PR_DEFAULT_STORE",
    PROP_ID(PR_STORE_SUPPORT_MASK), "PR_STORE_SUPPORT_MASK",
    PROP_ID(PR_IPM_SUBTREE_SEARCH_KEY), "PR_IPM_SUBTREE_SEARCH_KEY",
    PROP_ID(PR_IPM_OUTBOX_SEARCH_KEY),  "PR_IPM_OUTBOX_SEARCH_KEY",
    PROP_ID(PR_IPM_WASTEBASKET_SEARCH_KEY), "PR_IPM_WASTEBASKET_SEARCH_KEY",
    PROP_ID(PR_IPM_SENTMAIL_SEARCH_KEY),    "PR_IPM_SENTMAIL_SEARCH_KEY",
    PROP_ID(PR_MDB_PROVIDER),   "PR_MDB_PROVIDER",
    PROP_ID(PR_RECEIVE_FOLDER_SETTINGS),    "PR_RECEIVE_FOLDER_SETTINGS",
    PROP_ID(PR_VALID_FOLDER_MASK),  "PR_VALID_FOLDER_MASK",
    PROP_ID(PR_IPM_SUBTREE_ENTRYID),    "PR_IPM_SUBTREE_ENTRYID",
    PROP_ID(PR_IPM_OUTBOX_ENTRYID), "PR_IPM_OUTBOX_ENTRYID",
    PROP_ID(PR_IPM_WASTEBASKET_ENTRYID),    "PR_IPM_WASTEBASKET_ENTRYID",
    PROP_ID(PR_IPM_SENTMAIL_ENTRYID),   "PR_IPM_SENTMAIL_ENTRYID",
    PROP_ID(PR_VIEWS_ENTRYID),  "PR_VIEWS_ENTRYID",
    PROP_ID(PR_COMMON_VIEWS_ENTRYID),   "PR_COMMON_VIEWS_ENTRYID",
    PROP_ID(PR_FINDER_ENTRYID), "PR_FINDER_ENTRYID",
    PROP_ID(PR_CONTAINER_FLAGS),    "PR_CONTAINER_FLAGS",
    PROP_ID(PR_FOLDER_TYPE),    "PR_FOLDER_TYPE",
    PROP_ID(PR_CONTENT_COUNT),  "PR_CONTENT_COUNT",
    PROP_ID(PR_CONTENT_UNREAD), "PR_CONTENT_UNREAD",
    PROP_ID(PR_CREATE_TEMPLATES),   "PR_CREATE_TEMPLATES",
    PROP_ID(PR_DETAILS_TABLE),  "PR_DETAILS_TABLE",
    PROP_ID(PR_SEARCH), "PR_SEARCH",
    PROP_ID(PR_SELECTABLE), "PR_SELECTABLE",
    PROP_ID(PR_SUBFOLDERS), "PR_SUBFOLDERS",
    PROP_ID(PR_STATUS), "PR_STATUS",
    PROP_ID(PR_ANR),    "PR_ANR",
    PROP_ID(PR_CONTENTS_SORT_ORDER),    "PR_CONTENTS_SORT_ORDER",
    PROP_ID(PR_CONTAINER_HIERARCHY),    "PR_CONTAINER_HIERARCHY",
    PROP_ID(PR_CONTAINER_CONTENTS), "PR_CONTAINER_CONTENTS",
    PROP_ID(PR_FOLDER_ASSOCIATED_CONTENTS), "PR_FOLDER_ASSOCIATED_CONTENTS",
    PROP_ID(PR_DEF_CREATE_DL),  "PR_DEF_CREATE_DL",
    PROP_ID(PR_DEF_CREATE_MAILUSER),    "PR_DEF_CREATE_MAILUSER",
    PROP_ID(PR_CONTAINER_CLASS),    "PR_CONTAINER_CLASS",
    PROP_ID(PR_CONTAINER_MODIFY_VERSION),   "PR_CONTAINER_MODIFY_VERSION",
    PROP_ID(PR_AB_PROVIDER_ID), "PR_AB_PROVIDER_ID",
    PROP_ID(PR_ATTACHMENT_X400_PARAMETERS), "PR_ATTACHMENT_X400_PARAMETERS",
    PROP_ID(PR_ATTACH_DATA_BIN),    "PR_ATTACH_DATA_BIN",
    PROP_ID(PR_ATTACH_DATA_OBJ),    "PR_ATTACH_DATA_OBJ",
    PROP_ID(PR_ATTACH_ENCODING),    "PR_ATTACH_ENCODING",
    PROP_ID(PR_ATTACH_EXTENSION),   "PR_ATTACH_EXTENSION",
    PROP_ID(PR_ATTACH_FILENAME),    "PR_ATTACH_FILENAME",
    PROP_ID(PR_ATTACH_METHOD),  "PR_ATTACH_METHOD",
    PROP_ID(PR_ATTACH_LONG_FILENAME),   "PR_ATTACH_LONG_FILENAME",
    PROP_ID(PR_ATTACH_PATHNAME),    "PR_ATTACH_PATHNAME",
    PROP_ID(PR_ATTACH_RENDERING),   "PR_ATTACH_RENDERING",
    PROP_ID(PR_ATTACH_TAG), "PR_ATTACH_TAG",
    PROP_ID(PR_RENDERING_POSITION), "PR_RENDERING_POSITION",
    PROP_ID(PR_ATTACH_TRANSPORT_NAME),  "PR_ATTACH_TRANSPORT_NAME",
    PROP_ID(PR_DISPLAY_TYPE),   "PR_DISPLAY_TYPE",
    PROP_ID(PR_TEMPLATEID), "PR_TEMPLATEID",
    PROP_ID(PR_PRIMARY_CAPABILITY), "PR_PRIMARY_CAPABILITY",
    PROP_ID(PR_ACCOUNT),    "PR_ACCOUNT",
    PROP_ID(PR_ALTERNATE_RECIPIENT),    "PR_ALTERNATE_RECIPIENT",
    PROP_ID(PR_CALLBACK_TELEPHONE_NUMBER),  "PR_CALLBACK_TELEPHONE_NUMBER",
    PROP_ID(PR_CONVERSION_PROHIBITED),  "PR_CONVERSION_PROHIBITED",
    PROP_ID(PR_DISCLOSE_RECIPIENTS),    "PR_DISCLOSE_RECIPIENTS",
    PROP_ID(PR_GENERATION), "PR_GENERATION",
    PROP_ID(PR_GIVEN_NAME), "PR_GIVEN_NAME",
    PROP_ID(PR_GOVERNMENT_ID_NUMBER),   "PR_GOVERNMENT_ID_NUMBER",
    PROP_ID(PR_OFFICE_TELEPHONE_NUMBER),    "PR_OFFICE_TELEPHONE_NUMBER",
    PROP_ID(PR_HOME_TELEPHONE_NUMBER),  "PR_HOME_TELEPHONE_NUMBER",
    PROP_ID(PR_INITIALS),   "PR_INITIALS",
    PROP_ID(PR_KEYWORD),    "PR_KEYWORD",
    PROP_ID(PR_LANGUAGE),   "PR_LANGUAGE",
    PROP_ID(PR_LOCATION),   "PR_LOCATION",
    PROP_ID(PR_MAIL_PERMISSION),    "PR_MAIL_PERMISSION",
    PROP_ID(PR_MHS_COMMON_NAME),    "PR_MHS_COMMON_NAME",
    PROP_ID(PR_ORGANIZATIONAL_ID_NUMBER),   "PR_ORGANIZATIONAL_ID_NUMBER",
    PROP_ID(PR_SURNAME),    "PR_SURNAME",
    PROP_ID(PR_ORIGINAL_ENTRYID),   "PR_ORIGINAL_ENTRYID",
    PROP_ID(PR_ORIGINAL_DISPLAY_NAME),  "PR_ORIGINAL_DISPLAY_NAME",
    PROP_ID(PR_ORIGINAL_SEARCH_KEY),    "PR_ORIGINAL_SEARCH_KEY",
    PROP_ID(PR_POSTAL_ADDRESS), "PR_POSTAL_ADDRESS",
    PROP_ID(PR_COMPANY_NAME),   "PR_COMPANY_NAME",
    PROP_ID(PR_TITLE),  "PR_TITLE",
    PROP_ID(PR_DEPARTMENT_NAME),    "PR_DEPARTMENT_NAME",
    PROP_ID(PR_OFFICE_LOCATION),    "PR_OFFICE_LOCATION",
    PROP_ID(PR_PRIMARY_TELEPHONE_NUMBER),   "PR_PRIMARY_TELEPHONE_NUMBER",
    PROP_ID(PR_OFFICE2_TELEPHONE_NUMBER),   "PR_OFFICE2_TELEPHONE_NUMBER",
    PROP_ID(PR_CELLULAR_TELEPHONE_NUMBER),  "PR_CELLULAR_TELEPHONE_NUMBER",
    PROP_ID(PR_RADIO_TELEPHONE_NUMBER), "PR_RADIO_TELEPHONE_NUMBER",
    PROP_ID(PR_CAR_TELEPHONE_NUMBER),   "PR_CAR_TELEPHONE_NUMBER",
    PROP_ID(PR_OTHER_TELEPHONE_NUMBER), "PR_OTHER_TELEPHONE_NUMBER",
    PROP_ID(PR_TRANSMITABLE_DISPLAY_NAME),  "PR_TRANSMITABLE_DISPLAY_NAME",
    PROP_ID(PR_STORE_PROVIDERS),    "PR_STORE_PROVIDERS",
    PROP_ID(PR_AB_PROVIDERS),   "PR_AB_PROVIDERS",
    PROP_ID(PR_TRANSPORT_PROVIDERS),    "PR_TRANSPORT_PROVIDERS",
    PROP_ID(PR_DEFAULT_PROFILE),    "PR_DEFAULT_PROFILE",
    PROP_ID(PR_AB_SEARCH_PATH), "PR_AB_SEARCH_PATH",
    PROP_ID(PR_AB_DEFAULT_DIR), "PR_AB_DEFAULT_DIR",
    PROP_ID(PR_AB_DEFAULT_PAB), "PR_AB_DEFAULT_PAB",
    PROP_ID(PR_FILTERING_HOOKS),    "PR_FILTERING_HOOKS",
    PROP_ID(PR_SERVICE_NAME),   "PR_SERVICE_NAME",
    PROP_ID(PR_SERVICE_DLL_NAME),   "PR_SERVICE_DLL_NAME",
    PROP_ID(PR_SERVICE_ENTRY_NAME), "PR_SERVICE_ENTRY_NAME",
    PROP_ID(PR_SERVICE_UID),    "PR_SERVICE_UID",
    PROP_ID(PR_SERVICE_EXTRA_UIDS), "PR_SERVICE_EXTRA_UIDS",
    PROP_ID(PR_SERVICES),   "PR_SERVICES",
    PROP_ID(PR_SERVICE_SUPPORT_FILES),  "PR_SERVICE_SUPPORT_FILES",
    PROP_ID(PR_SERVICE_DELETE_FILES),   "PR_SERVICE_DELETE_FILES",
    PROP_ID(PR_IDENTITY_DISPLAY),   "PR_IDENTITY_DISPLAY",
    PROP_ID(PR_IDENTITY_ENTRYID),   "PR_IDENTITY_ENTRYID",
    PROP_ID(PR_RESOURCE_METHODS),   "PR_RESOURCE_METHODS",
    PROP_ID(PR_RESOURCE_TYPE),  "PR_RESOURCE_TYPE",
    PROP_ID(PR_STATUS_CODE),    "PR_STATUS_CODE",
    PROP_ID(PR_IDENTITY_SEARCH_KEY),    "PR_IDENTITY_SEARCH_KEY",
    PROP_ID(PR_OWN_STORE_ENTRYID),  "PR_OWN_STORE_ENTRYID",
    PROP_ID(PR_RESOURCE_PATH),  "PR_RESOURCE_PATH",
    PROP_ID(PR_STATUS_STRING),  "PR_STATUS_STRING",
    PROP_ID(PR_X400_DEFERRED_DELIVERY_CANCEL),  "PR_X400_DEFERRED_DELIVERY_CANCEL",
    PROP_ID(PR_HEADER_FOLDER_ENTRYID),  "PR_HEADER_FOLDER_ENTRYID",
    PROP_ID(PR_REMOTE_PROGRESS),    "PR_REMOTE_PROGRESS'",
    PROP_ID(PR_REMOTE_PROGRESS_TEXT),   "PR_REMOTE_PROGRESS_TEXT",
    PROP_ID(PR_CONTROL_FLAGS),  "PR_CONTROL_FLAGS",
    PROP_ID(PR_CONTROL_STRUCTURE),  "PR_CONTROL_STRUCTURE",
    PROP_ID(PR_CONTROL_TYPE),   "PR_CONTROL_TYPE",
    PROP_ID(PR_DELTAX), "PR_DELTAX",
    PROP_ID(PR_DELTAY), "PR_DELTAY",
    PROP_ID(PR_XPOS),   "PR_XPOS",
    PROP_ID(PR_YPOS),   "PR_YPOS",
    PROP_ID(PR_CONTROL_ID), "PR_CONTROL_ID",
    PROP_ID(PR_INITIAL_DETAILS_PANE),   "PR_INITIAL_DETAILS_PANE"
};

/* Data for table: PropType */

static ENTRY s5[30] = 
{
    PT_UNSPECIFIED, "PT_UNSPECIFIED",
    PT_NULL,    "PT_NULL",
    PT_I2,  "PT_I2",
    PT_LONG,    "PT_LONG",
    PT_R4,  "PT_R4",
    PT_DOUBLE,  "PT_DOUBLE",
    PT_CURRENCY,    "PT_CURRENCY",
    PT_APPTIME, "PT_APPTIME",
    PT_ERROR,   "PT_ERROR",
    PT_BOOLEAN, "PT_BOOLEAN",
    PT_OBJECT,  "PT_OBJECT",
    PT_I8,  "PT_I8",
    PT_SYSTIME, "PT_SYSTIME",
    PT_STRING8, "PT_STRING8",
    PT_UNICODE, "PT_UNICODE",
    PT_CLSID,   "PT_CLSID",
    PT_BINARY,  "PT_BINARY",
    PT_MV_I2,   "PT_MV_I2",
    PT_MV_LONG, "PT_MV_LONG",
    PT_MV_R4,   "PT_MV_R4",
    PT_MV_DOUBLE,   "PT_MV_DOUBLE",
    PT_MV_CURRENCY, "PT_MV_CURRENCY",
    PT_MV_APPTIME,  "PT_MV_APPTIME",
    PT_MV_SYSTIME,  "PT_MV_SYSTIME",
    PT_MV_STRING8,  "PT_MV_STRING8",
    PT_MV_BINARY,   "PT_MV_BINARY",
    PT_MV_UNICODE,  "PT_MV_UNICODE",
    PT_MV_CLSID,    "PT_MV_CLSID",
    PT_MV_I8,   "PT_MV_I8",
    PT_MV_TSTRING,  "PT_MV_TSTRING"
};

/* Data for table: FolderType */

static ENTRY s6[3] = 
{
    FOLDER_GENERIC, "FOLDER_GENERIC",
    FOLDER_ROOT,    "FOLDER_ROOT",
    FOLDER_SEARCH,  "FOLDER_SEARCH"
};

/* Data for table: TableStatus */

static ENTRY s7[8] = 
{
    TBLSTAT_COMPLETE,   "TBLSTAT_COMPLETE",
    TBLSTAT_QCHANGED,   "TBLSTAT_QCHANGED",
    TBLSTAT_SORTING,    "TBLSTAT_SORTING",
    TBLSTAT_SORT_ERROR, "TBLSTAT_SORT_ERROR",
    TBLSTAT_SETTING_COLS,   "TBLSTAT_SETTING_COLS",
    TBLSTAT_SETCOL_ERROR,   "TBLSTAT_SETCOL_ERROR",
    TBLSTAT_RESTRICTING,    "TBLSTAT_RESTRICTING",
    TBLSTAT_RESTRICT_ERROR, "TBLSTAT_RESTRICT_ERROR"
};

/* Data for table: TableType */

static ENTRY s8[3] = 
{
    TBLTYPE_SNAPSHOT,   "TBLTYPE_SNAPSHOT",
    TBLTYPE_KEYSET, "TBLTYPE_KEYSET",
    TBLTYPE_DYNAMIC,    "TBLTYPE_DYNAMIC"
};

/* Data for table: SortOrder */

static ENTRY s9[3] = 
{
    TABLE_SORT_ASCEND,  "TABLE_SORT_ASCEND",
    TABLE_SORT_DESCEND, "TABLE_SORT_DESCEND",
    TABLE_SORT_COMBINE, "TABLE_SORT_COMBINE"
};

/* Data for table: RestrictionType */

static ENTRY s10[11] = 
{
    RES_AND,    "RES_AND",
    RES_OR, "RES_OR",
    RES_NOT,    "RES_NOT",
    RES_CONTENT,    "RES_CONTENT",
    RES_PROPERTY,   "RES_PROPERTY",
    RES_COMPAREPROPS,   "RES_COMPAREPROPS",
    RES_BITMASK,    "RES_BITMASK",
    RES_SIZE,   "RES_SIZE",
    RES_EXIST,  "RES_EXIST",
    RES_SUBRESTRICTION, "RES_SUBRESTRICTION",
    RES_COMMENT,    "RES_COMMENT"
};

/* Data for table: RelOp */

static ENTRY s11[7] = 
{
    RELOP_LT,   "<",
    RELOP_LE,   "<=",
    RELOP_GT,   ">",
    RELOP_GE,   ">=",
    RELOP_EQ,   "==",
    RELOP_NE,   "!=",
    RELOP_RE,   "LIKE"
};

/* Data for table: Bmr */

static ENTRY s12[2] = 
{
    BMR_EQZ,    "==0",
    BMR_NEZ,    "!=0"
};

/* Data for table: FuzzyLevel */

static ENTRY s13[6] = 
{
    FL_FULLSTRING,  "FL_FULLSTRING",
    FL_SUBSTRING,   "FL_SUBSTRING",
    FL_PREFIX,  "FL_PREFIX",
    FL_IGNORECASE,  "FL_IGNORECASE",
    FL_IGNORENONSPACE,  "FL_IGNORENONSPACE",
    FL_LOOSE,   "FL_LOOSE"
};

/* Data for table: MAPIObjTypes */

static ENTRY s14[12] = 
{
    MAPI_STORE, "MAPI_STORE",
    MAPI_ADDRBOOK,  "MAPI_ADDRBOOK",
    MAPI_FOLDER,    "MAPI_FOLDER",
    MAPI_ABCONT,    "MAPI_ABCONT",
    MAPI_MESSAGE,   "MAPI_MESSAGE",
    MAPI_MAILUSER,  "MAPI_MAILUSER",
    MAPI_ATTACH,    "MAPI_ATTACH",
    MAPI_DISTLIST,  "MAPI_DISTLIST",
    MAPI_PROFSECT,  "MAPI_PROFSECT",
    MAPI_STATUS,    "MAPI_STATUS",
    MAPI_SESSION,   "MAPI_SESSION",
    MAPI_FORMINFO,  "MAPI_FORMINFO"
};

/* Data for table: NotifEvents */

static ENTRY s15[12] = 
{
    fnevCriticalError,  "fnevCriticalError",
    fnevNewMail,    "fnevNewMail",
    fnevObjectCreated,  "fnevObjectCreated",
    fnevObjectDeleted,  "fnevObjectDeleted",
    fnevObjectModified, "fnevObjectModified",
    fnevObjectMoved,    "fnevObjectMoved",
    fnevSearchComplete, "fnevSearchComplete",
    fnevObjectCopied,   "fnevObjectCopied",
    fnevTableModified,  "fnevTableModified",
    fnevStatusObjectModified,   "fnevStatusObjectModified",
    fnevReservedForMapi,    "fnevReservedForMapi",
    fnevExtended,   "fnevExtended"
};

/* Data for table: TableEvents */

static ENTRY s16[8] = 
{
    TABLE_CHANGED,  "TABLE_CHANGED",
    TABLE_ERROR,    "TABLE_ERROR",
    TABLE_ROW_ADDED,    "TABLE_ROW_ADDED",
    TABLE_ROW_DELETED,  "TABLE_ROW_DELETED",
    TABLE_ROW_MODIFIED, "TABLE_ROW_MODIFIED",
    TABLE_SORT_DONE,    "TABLE_SORT_DONE",
    TABLE_RESTRICT_DONE,    "TABLE_RESTRICT_DONE",
    TABLE_SETCOL_DONE,  "TABLE_SETCOL_DONE"
};

/* Data for table: MsgFlags */

static ENTRY s17[8] = 
{
    MSGFLAG_READ,   "MSGFLAG_READ",
    MSGFLAG_UNMODIFIED, "MSGFLAG_UNMODIFIED",
    MSGFLAG_SUBMIT, "MSGFLAG_SUBMIT",
    MSGFLAG_UNSENT, "MSGFLAG_UNSENT",
    MSGFLAG_HASATTACH,  "MSGFLAG_HASATTACH",
    MSGFLAG_FROMME, "MSGFLAG_FROMME",
    MSGFLAG_ASSOCIATED, "MSGFLAG_ASSOCIATED",
    MSGFLAG_RESEND, "MSGFLAG_RESEND"
};

/* Data for table: RecipType */

static ENTRY s18[4] = 
{
    MAPI_ORIG,  "MAPI_ORIG",
    MAPI_TO,    "MAPI_TO",
    MAPI_CC,    "MAPI_CC",
    MAPI_BCC,   "MAPI_BCC"
};

/* Data for table: EIDFlags */

static ENTRY s19[5] = 
{
    MAPI_SHORTTERM, "MAPI_SHORTTERM",
    MAPI_NOTRECIP,  "MAPI_NOTRECIP",
    MAPI_THISSESSION,   "MAPI_THISSESSION",
    MAPI_NOW,   "MAPI_NOW",
    MAPI_NOTRESERVED,   "MAPI_NOTRESERVED"
};

/* Data for table: ResourceType */

static ENTRY s20[8] = 
{
    MAPI_STORE_PROVIDER,    "MAPI_STORE_PROVIDER",
    MAPI_AB,    "MAPI_AB",
    MAPI_AB_PROVIDER,   "MAPI_AB_PROVIDER",
    MAPI_TRANSPORT_PROVIDER,    "MAPI_TRANSPORT_PROVIDER",
    MAPI_SPOOLER,   "MAPI_SPOOLER",
    MAPI_PROFILE_PROVIDER,  "MAPI_PROFILE_PROVIDER",
    MAPI_SUBSYSTEM, "MAPI_SUBSYSTEM",
    MAPI_HOOK_PROVIDER, "MAPI_HOOK_PROVIDER"
};

/* Data for table: Priority */

static ENTRY s21[3] = 
{
    PRIO_URGENT,    "PRIO_URGENT",
    PRIO_NORMAL,    "PRIO_NORMAL",
    PRIO_NONURGENT, "PRIO_NONURGENT"
};

/* Data for table: AttachMethod */

static ENTRY s22[7] = 
{
    NO_ATTACHMENT,  "NO_ATTACHMENT",
    ATTACH_BY_VALUE,    "ATTACH_BY_VALUE",
    ATTACH_BY_REFERENCE,    "ATTACH_BY_REFERENCE",
    ATTACH_BY_REF_RESOLVE,  "ATTACH_BY_REF_RESOLVE",
    ATTACH_BY_REF_ONLY, "ATTACH_BY_REF_ONLY",
    ATTACH_EMBEDDED_MSG,    "ATTACH_EMBEDDED_MSG",
    ATTACH_OLE, "ATTACH_OLE"
};

/* The top-level Table Struct */

static STRTBL st[22] = 
{
    { "MAPIErrors", 98, s1 },
    { "CMCErrors", 39, s2 },
    { "PropTags", 338, s3 },
    { "PropIDs", 338, s4 },
    { "PropType", 30, s5 },
    { "FolderType", 3, s6 },
    { "TableStatus", 8, s7 },
    { "TableType", 3, s8 },
    { "SortOrder", 3, s9 },
    { "RestrictionType", 11, s10 },
    { "RelOp", 7, s11 },
    { "Bmr", 2, s12 },
    { "FuzzyLevel", 6, s13 },
    { "MAPIObjTypes", 12, s14 },
    { "NotifEvents", 12, s15 },
    { "TableEvents", 8, s16 },
    { "MsgFlags", 8, s17 },
    { "RecipType", 4, s18 },
    { "EIDFlags", 5, s19 },
    { "ResourceType", 8, s20 },
    { "Priority", 3, s21 },
    { "AttachMethod", 7, s22 }
};